; The library glue routines need the _LVOs to be defined for any
; lib entry. That's the reason why this file is around. Note that
; ALL arp.lib entries are displayed below.
;
; 17-Mar-90:	Made some changes
; 10-Mar-90:	Olsen created this file (yes he did).

	SECTION	text,CODE	; Make the asm happy

*-------------------------------------------------------------------*
*	A bunch of XDEFs, the EQUs are to follow soon.
*-------------------------------------------------------------------*

	XDEF	_LVOPrintf
	XDEF	_LVOFPrintf
	XDEF	_LVOPuts
	XDEF	_LVOReadLine
	XDEF	_LVOGADS
	XDEF	_LVOAtol
	XDEF	_LVOEscapeString
	XDEF	_LVOCheckAbort
	XDEF	_LVOCheckBreak
	XDEF	_LVOGetenv
	XDEF	_LVOSetenv
	XDEF	_LVOFileRequest
	XDEF	_LVOCloseWindowSafely
	XDEF	_LVOCreatePort
	XDEF	_LVODeletePort
	XDEF	_LVOSendPacket
	XDEF	_LVOInitStdPacket
	XDEF	_LVOPathName
	XDEF	_LVOAssign
	XDEF	_LVODosAllocMem
	XDEF	_LVODosFreeMem
	XDEF	_LVOBtoCStr
	XDEF	_LVOCtoBStr
	XDEF	_LVOGetDevInfo
	XDEF	_LVOFreeTaskResList
	XDEF	_LVOArpExit
	XDEF	_LVOArpAlloc
	XDEF	_LVOArpAllocMem
	XDEF	_LVOArpOpen
	XDEF	_LVOArpDupLock
	XDEF	_LVOArpLock
	XDEF	_LVORListAlloc
	XDEF	_LVOFindCLI
	XDEF	_LVOQSort
	XDEF	_LVOPatternMatch
	XDEF	_LVOFindFirst
	XDEF	_LVOFindNext
	XDEF	_LVOFreeAnchorChain
	XDEF	_LVOCompareLock
	XDEF	_LVOFindTaskResList
	XDEF	_LVOCreateTaskResList
	XDEF	_LVOFreeResList
	XDEF	_LVOFreeTrackedItem
	XDEF	_LVOGetTracker
	XDEF	_LVOGetAccess
	XDEF	_LVOFreeAccess
	XDEF	_LVOFreeDAList
	XDEF	_LVOAddDANode
	XDEF	_LVOAddDADevs
	XDEF	_LVOStrcmp
	XDEF	_LVOStrncmp
	XDEF	_LVOToupper
	XDEF	_LVOSyncRun
	XDEF	_LVOASyncRun
	XDEF	_LVOLoadPrg
	XDEF	_LVOPreParse
	XDEF	_LVOStamptoStr
	XDEF	_LVOStrtoStamp
	XDEF	_LVOObtainResidentPrg
	XDEF	_LVOAddResidentPrg
	XDEF	_LVORemResidentPrg
	XDEF	_LVOUnLoadPrg
	XDEF	_LVOLMult
	XDEF	_LVOLDiv
	XDEF	_LVOLMod
	XDEF	_LVOCheckSumPrg
	XDEF	_LVOTackOn
	XDEF	_LVOBaseName
	XDEF	_LVOReleaseResidentPrg
	XDEF	_LVOSPrintf
	XDEF	_LVOGetKeywordIndex
	XDEF	_LVOArpOpenLibrary
	XDEF	_LVOArpAllocFreq

*-------------------------------------------------------------------*
*	As promised, here are the EQUs...
*-------------------------------------------------------------------*

_LVOPrintf		EQU -228
_LVOFPrintf		EQU -234
_LVOPuts		EQU -240
_LVOReadLine		EQU -246
_LVOGADS		EQU -252
_LVOAtol		EQU -258
_LVOEscapeString	EQU -264
_LVOCheckAbort		EQU -270
_LVOCheckBreak		EQU -276
_LVOGetenv		EQU -282
_LVOSetenv		EQU -288
_LVOFileRequest		EQU -294
_LVOCloseWindowSafely	EQU -300
_LVOCreatePort		EQU -306
_LVODeletePort		EQU -312
_LVOSendPacket		EQU -318
_LVOInitStdPacket	EQU -324
_LVOPathName		EQU -330
_LVOAssign		EQU -336
_LVODosAllocMem		EQU -342
_LVODosFreeMem		EQU -348
_LVOBtoCStr		EQU -354
_LVOCtoBStr		EQU -360
_LVOGetDevInfo		EQU -366
_LVOFreeTaskResList	EQU -372
_LVOArpExit		EQU -378
_LVOArpAlloc		EQU -384
_LVOArpAllocMem		EQU -390
_LVOArpOpen		EQU -396
_LVOArpDupLock		EQU -402
_LVOArpLock		EQU -408
_LVORListAlloc		EQU -414
_LVOFindCLI		EQU -420
_LVOQSort		EQU -426
_LVOPatternMatch	EQU -432
_LVOFindFirst		EQU -438
_LVOFindNext		EQU -444
_LVOFreeAnchorChain	EQU -450
_LVOCompareLock		EQU -456
_LVOFindTaskResList	EQU -462
_LVOCreateTaskResList	EQU -468
_LVOFreeResList		EQU -474
_LVOFreeTrackedItem	EQU -480
_LVOGetTracker		EQU -486
_LVOGetAccess		EQU -492
_LVOFreeAccess		EQU -498
_LVOFreeDAList		EQU -504
_LVOAddDANode		EQU -510
_LVOAddDADevs		EQU -516
_LVOStrcmp		EQU -522
_LVOStrncmp		EQU -528
_LVOToupper		EQU -534
_LVOSyncRun		EQU -540
_LVOASyncRun		EQU -546
_LVOLoadPrg		EQU -552
_LVOPreParse		EQU -558
_LVOStamptoStr		EQU -564
_LVOStrtoStamp		EQU -570
_LVOObtainResidentPrg	EQU -576
_LVOAddResidentPrg	EQU -582
_LVORemResidentPrg	EQU -588
_LVOUnLoadPrg		EQU -594
_LVOLMult		EQU -600
_LVOLDiv		EQU -606
_LVOLMod		EQU -612
_LVOCheckSumPrg		EQU -618
_LVOTackOn		EQU -624
_LVOBaseName		EQU -630
_LVOReleaseResidentPrg	EQU -636
_LVOSPrintf		EQU -642
_LVOGetKeywordIndex	EQU -648
_LVOArpOpenLibrary	EQU -654
_LVOArpAllocFreq	EQU -660

	END		; Make the asm even happier
