/*files.h*/
/* for AlgoRhythms.c by Thomas E. Janzen */
int Save_File(char *FileName, const double *TotalDuration, 
	const int *ScaleLength, const int Scale[], const int *voices,
	const int *tempo,
	const struct Parameter *Pitch, const struct Parameter *Thickness,
	const struct Parameter *Dynamics, 
	const struct Parameter *Duration,
	const struct NoteEvent *Events,
	double MinNoteLen, double MaxNoteLen);
	
int Read_File(char *FileName, double *TotalDuration,  
	int *ScaleLength, int Scale[], int *voices, int *tempo,
	struct Parameter *Pitch, struct Parameter *Thickness,
	struct Parameter *Dynamics, struct Parameter *Duration,
	struct NoteEvent *Events,
	double *MinNoteLen, double *MaxNoteLen);
