/*	menu stuff for PUZZ		M.J.Round	Jan 1990.	*/

extern struct TextAttr MyFont;

struct IntuiText starttext =
	{
	1,  						/*	Front Pen			*/
	0,  						/*	Back pen			*/
	JAM2,						/*	Draw Mode			*/
	0,  						/*	Left Edge			*/
	1,  						/*	Top					*/
	&MyFont,					/*	pointer to TextFont */
	"Start",					/*	text				*/
	NULL						/*	next				*/
	};

struct MenuItem startitem =
	{
	NULL,						/*	pointer to next item	*/
	0,  						/*	left					*/
	0,  						/*	top 					*/
	40, 						/*	width					*/
	9,  						/*	height  				*/
	ITEMTEXT
	| ITEMENABLED
	| HIGHCOMP, 				/*	flags						*/
	0,  						/*	no mutual exclude			*/
	(APTR)&starttext,			/*	Render  					*/
	NULL,						/*	pointer to alternate image	*/
	NULL,						/*	Command "amiga" char		*/
	NULL,						/*	Sub Item					*/
	MENUNULL					/* 	nextselect					*/
	};

/*	similarly for the other menus....	*/

struct IntuiText abouttext1 =
{1,0,JAM2,0,1,&MyFont,"PUZZ  V 1.0 ",NULL};
struct IntuiText abouttext2 =
{1,0,JAM2,0,1,&MyFont," Written by ",NULL};
struct IntuiText abouttext3 =
{1,0,JAM2,0,1,&MyFont,"Martin Round",NULL};
struct IntuiText abouttext4 =
{1,0,JAM2,0,1,&MyFont,"24 Jan 1990.",NULL};
struct IntuiText abouttext5 =
{1,0,JAM2,0,1,&MyFont," Shareware. ",NULL};

struct IntuiText instrtext[6] =
{
	{1,0,JAM2,0,1,&MyFont,"..........................",NULL},
	{1,0,JAM2,0,1,&MyFont,"..........................",NULL},
	{1,0,JAM2,0,1,&MyFont,"..........................",NULL},
	{1,0,JAM2,0,1,&MyFont,"..........................",NULL},
	{1,0,JAM2,0,1,&MyFont,"..........................",NULL},
	{1,0,JAM2,0,1,&MyFont,"..........................",NULL}
};

struct IntuiText quittext =
{1,0,JAM2,0,1,&MyFont,"Quit",NULL};

struct MenuItem aboutitem5 = 
{
NULL,0,36,96,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&abouttext5,NULL,NULL,NULL,MENUNULL
};

struct MenuItem aboutitem4 = 
{
&aboutitem5,0,27,96,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&abouttext4,NULL,NULL,NULL,MENUNULL
};

struct MenuItem aboutitem3 = 
{
&aboutitem4,0,18,96,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&abouttext3,NULL,NULL,NULL,MENUNULL
};

struct MenuItem aboutitem2 = 
{
&aboutitem3,0,9,96,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&abouttext2,NULL,NULL,NULL,MENUNULL
};

struct MenuItem aboutitem1 = 
{
&aboutitem2,0,0,96,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&abouttext1,NULL,NULL,NULL,MENUNULL
};

struct MenuItem instritem6 =
{
NULL,0,45,208,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&(instrtext[5]),NULL,NULL,NULL,MENUNULL
};

struct MenuItem instritem5 =
{
&instritem6,0,36,208,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&(instrtext[4]),NULL,NULL,NULL,MENUNULL
};

struct MenuItem instritem4 =
{
&instritem5,0,27,208,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&(instrtext[3]),NULL,NULL,NULL,MENUNULL
};

struct MenuItem instritem3 =
{
&instritem4,0,18,208,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&(instrtext[2]),NULL,NULL,NULL,MENUNULL
};

struct MenuItem instritem2 =
{
&instritem3,0,9,208,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&(instrtext[1]),NULL,NULL,NULL,MENUNULL
};

struct MenuItem instritem1 =
{
&instritem2,0,0,208,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&(instrtext[0]),NULL,NULL,NULL,MENUNULL
};

struct MenuItem quititem =
{
NULL,0,0,32,9,ITEMTEXT | ITEMENABLED | HIGHCOMP,0,
(APTR)&quittext,NULL,NULL,NULL,MENUNULL
};

struct Menu aboutmenu =
	{
	NULL,					/*	pointer to next menu	*/
	216,0,40,0, 			/*	left,0,Width,0  		*/
	MENUENABLED,			/*	flags					*/
	"About",				/*	menu name				*/
	&aboutitem1 			/*	First Item in list  	*/
	};

struct Menu instrmenu =
	{
	&aboutmenu, 			/*	pointer to next menu	*/
	104,0,96,0, 			/*	left,0,Width,0  		*/
	MENUENABLED,			/*	flags					*/
	"Instructions", 		/*	menu name				*/
	&instritem1 			/*	First Item in list  	*/
	};

struct Menu quitmenu =
	{
	&instrmenu, 			/*	pointer to next menu	*/
	56,0,32,0,  			/*	left,0,Width,0  		*/
	MENUENABLED,			/*	flags					*/
	"Quit", 				/*	menu name				*/
	&quititem				/*	First Item in list  	*/
	};

struct Menu MyMenu =
	{
	&quitmenu,  			/*	pointer to next menu	*/
	2,0,40,0,				/*	left,0,Width,0  		*/
	MENUENABLED,			/*	flags					*/
	"Start",				/*	menu name				*/
	&startitem  			/*	First Item in list  	*/
	};
