/* Prototypes for functions defined in backup.c */
void *MakeDB(int len);
void FreeDB(struct IORequest *req);
short InitDevice(char *name,
                 int unit,
                 struct IORequest **req,
                 unsigned int fl,
                 unsigned int len);
void ExitDevice(struct IORequest *req);
void DeviceCommand(struct IORequest *db,
                   unsigned short com);
char *TrackDiskError(int fn);
void WaitDisk(struct IOExtTD *db);
void ReadTrack(struct IOExtTD *db,
               char *tbuf,
               char *lbuf,
               int nr);
void CloseAll(int err);
void UserRequest(void);
int DoNothing(void);
void OpenAll(int devunit);
void ConcatPath(char *buffer,
                char *p1,
                char *p2);
short FileAbfrage(void);
struct IOAudio *MakeIOA(int rate,
                        int vol,
                        int repeat,
                        unsigned char *buf,
                        int len);
void Beep(int freq,
          int dauer,
          int vol);
void PrintTrack(int nr);
void PrintDisk(int nr);
void NewDisk(void);
void FormatTrack(struct IOExtTD *db,
                 int nr,
                 char *buf);
void RawPutByte(char b);
void EncodeByte(char b);
void RawWrite(char *buf,
              int len);
int ByteCount(unsigned char *begin,
              unsigned char *max);
void EndBackup(void);
short BackupFile(char *path,
                 struct FileInfoBlock *fib);
short BackupDir(char *path,
                struct FileInfoBlock *fib);
void BackupEndDir(void);
short BackupTree(char *s);
short StrToDs(char *s,
              struct DateStamp *ds);
void main(int argc,
          char **argv);
