/* Prototypes for functions defined in easymouse.c */
short TestMsg(struct Window *win);
void *GetDeviceBlock(unsigned int size);
void FreeDeviceBlock(struct IORequest *iorequest);
short Open_A_Device(char *name,
                    unsigned int unit,
                    struct IORequest **device_request,
                    unsigned int flags,
                    unsigned int size);
void Close_A_Device(struct IORequest *iorequest);
void Do_Command(struct IORequest *deviceblock,
                unsigned short command);
void Input_AddHandler(struct IOStdReq *ireq,
                      void *handler,
                      unsigned char **data);
void Input_RemHandler(struct IOStdReq *ireq);
void CloseAll(register char *str);
void SetOptions(void);
void SetWindow(void);
struct Window *MouseWindow(void);
void BlackScreen(void);
void NormalScreen(void);
struct InputEvent * __saveds __interrupt IHandler(void);
void OpenAll(void);
void main(int argc,
          char **argv);
