/****************************************

         File dati di View80

****************************************/


/*****   Messaggi ricorrenti   *****/
UBYTE	nofilestr[]="No file loaded";
UBYTE	noreqstr[]="Cannot open the requester";
UBYTE	priprostr[]="Printer or disk problem";
UBYTE	quitstr[]="QUIT ?!?  Are you sure?";


UWORD	colormap[]=
	{
	0x05A,
	0xFFF,
	0x000,
	0xF80
	};

struct TextAttr tanormal=
	{
	"topaz.font",
	8,
	FS_NORMAL,
	FPF_ROMFONT,
	};
struct TextAttr tabold=
	{
	"topaz.font",
	8,
	FSF_BOLD,
	FPF_ROMFONT
	};
struct TextAttr taitalic=
	{
	"topaz.font",
	8,
	FSF_ITALIC,
	FPF_ROMFONT
	};
struct TextAttr taunderlined=
	{
	"topaz.font",
	8,
	FSF_UNDERLINED,
	FPF_ROMFONT
	};

UWORD   __chip  byData[32] = {
	/* BitPlane 0 */
   0xE000,0x0001,0xFF1F,0xC000,
   0x6000,0x0000,0xC030,0x2000,
   0x6E1E,0x7000,0xFC60,0x0000,
   0x730C,0x2000,0xC060,0xF000,
   0x6306,0x4000,0xC030,0x6000,
   0x3E03,0x8001,0xE01F,0xC000,
   0x0031,0x0000,0x0000,0x0000,
   0x001E,0x0000,0x0000,0x0000,
};
struct Image byImage = {
	-((MENUW-52)/2+52), -(MENUH-4-19),		/* LeftEdge, TopEdge */
	52, 8, 2,	/* Width, Height, Depth */
	&byData[0],	/* ImageData */
	0x01, 0x02,	/* PlanePick, PlaneOnOff */
	NULL		/* NextImage */
};

UWORD __chip logoData[156] = {
	/* BitPlane 0 */
   0x00F8,0x78E0,0x0000,0x0001,0xF807,0xE000,
   0x0070,0x30E0,0x0000,0x0007,0x0E1C,0x3800,
   0x0070,0x3000,0x0000,0x000E,0x0738,0x3C00,
   0x0038,0x6000,0x0000,0x0007,0x0E38,0x7C00,
   0x0038,0x61E0,0x7C3E,0xFBE1,0xF838,0xDC00,
   0x001C,0xC0E1,0xC71C,0x70C7,0x0E39,0x9C00,
   0x001C,0xC0E3,0x839C,0x70CE,0x073B,0x1C00,
   0x000F,0x80E3,0xFF8E,0x718E,0x073E,0x1C00,
   0x000F,0x80E3,0x800E,0x718E,0x0738,0x1C00,
   0x0007,0x00E1,0xC387,0xDF07,0x0E1C,0x3800,
   0x0007,0x01F0,0x7E03,0x8E01,0xF807,0xE000,
   0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
   0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFE,
	/* BitPlane 1 */
   0xFF07,0x871F,0xFFFF,0xFFFE,0x07F8,0x1FFF,
   0xFF8F,0xCF1F,0xFFFF,0xFFF8,0xF1E3,0xC7FF,
   0xFF8F,0xCFFF,0xFFFF,0xFFF1,0xF8C7,0xC3FF,
   0xFFC7,0x9FFF,0xFFFF,0xFFF8,0xF1C7,0x83FF,
   0xFFC7,0x9E1F,0x83C1,0x041E,0x07C7,0x23FF,
   0xFFE3,0x3F1E,0x38E3,0x8F38,0xF1C6,0x63FF,
   0xFFE3,0x3F1C,0x7C63,0x8F31,0xF8C4,0xE3FF,
   0xFFF0,0x7F1C,0x0071,0x8E71,0xF8C1,0xE3FF,
   0xFFF0,0x7F1C,0x7FF1,0x8E71,0xF8C7,0xE3FF,
   0xFFF8,0xFF1E,0x3C78,0x20F8,0xF1E3,0xC7FF,
   0xFFF8,0xFE0F,0x81FC,0x71FE,0x07F8,0x1FFF,
   0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
   0x0000,0x0000,0x0000,0x0000,0x0000,0x0001
};
struct Image logoImage = {
	-((MENUW-95)/2+95), -(MENUH-4),		/* LeftEdge, TopEdge */
	95, 13, 2,	/* Width, Height, Depth */
	&logoData[0],	/* ImageData */
	0x03, 0x00,	/* PlanePick, PlaneOnOff */
	&byImage		/* NextImage */
};


UWORD	__chip	cancelData[110] = {
	/* BitPlane 0 */
   0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFF0,
   0xFFF3,0xF9FC,0xFCFF,0xEFFD,0xE3F0,
   0xF871,0xFCFE,0x7DF0,0xEF01,0xE3F0,
   0xF0F3,0xDE7F,0x3DE1,0xEF1F,0xE3F0,
   0xF1FF,0x8F7F,0xBDE3,0xFFFF,0xE3F0,
   0xF1FF,0xFF7B,0xFDE3,0xFFE3,0xE3F0,
   0xF1FF,0xFF79,0xFDE3,0xFF03,0xE3F0,
   0xF9FF,0x0778,0xFDF3,0xFF1F,0xE3F0,
   0xFFF7,0x1F78,0xFCFF,0xEFFF,0xFFF0,
   0xFFE7,0x1F78,0xFC7F,0xCFFD,0xFF80,
   0xF803,0x1F10,0xF870,0x0600,0x4000,
	/* BitPlane 1 */
   0x3FE0,0x7078,0x3C7F,0xCFFD,0xE000,
   0x7FFC,0xFE7F,0x3FFF,0xFFFF,0xFC00,
   0xFFFF,0xFF7F,0xBFFF,0xFFFF,0xFC00,
   0xFF0F,0xFFFF,0xFFFE,0x1FE1,0xFC00,
   0xFE07,0xFFFF,0xFFFC,0x0FE1,0xFC00,
   0xFE07,0xFFFF,0xFFFC,0x0FFD,0xFC00,
   0xFE07,0xFFFF,0xFFFC,0x0FFD,0xFC00,
   0xFE77,0xFFFF,0xFFFC,0xEFE1,0xFC00,
   0x7FFF,0xE7FF,0x7FFF,0xFFFD,0xFF80,
   0x3FFF,0xE7FF,0x3FFF,0xFFFF,0xFFF0,
   0x07FC,0xE0EF,0x078F,0xF9FF,0xBFF0
};
struct Image cancelImage = {
	(REQGW-CANCELGW)/2, 1,		/* LeftEdge, TopEdge */
	76, 11, 2,	/* Width, Height, Depth */
	&cancelData[0],	/* ImageData */
	0x03, 0x00,	/* PlanePick, PlaneOnOff */
	NULL		/* NextImage */
};
struct Gadget cancelGadg = {
	NULL,		/* NextGadget */
	-REQGW-REQGL, REQGB,		/* LeftEdge, TopEdge */
	REQGW, REQGH,		/* Width, Height */
	GADGIMAGE | GADGHBOX | GRELBOTTOM | GRELRIGHT,	/* Flags */
	RELVERIFY | ENDGADGET,	/* Activation */
	BOOLGADGET | REQGADGET,	/* GadgetType */
	(APTR)&cancelImage,	/* GadgetRender */
	NULL,		/* SelectRender */
	NULL,		/* GadgetText */
	0L,		/* MutualExclude */
	NULL,		/* SpecialInfo */
	CANCELID,		/* GadgetID */
	NULL,		/* UserData */
};


UWORD	__chip	okData[44] = {
	/* BitPlane 0 */
   0xFFFF,0xFFF8,
   0xFFF3,0xDF08,
   0xF8FB,0xFE18,
   0xF0FB,0xFC38,
   0xF1FB,0xF878,
   0xF1FB,0xFCF8,
   0xF1FB,0xDE78,
   0xF9FB,0xCF38,
   0xFFF3,0xC798,
   0xFFE3,0xC7C8,
   0xF803,0x8780,
	/* BitPlane 1 */
   0x3FE3,0xCF80,
   0x7FFF,0xFFF0,
   0xFFFF,0xFFE0,
   0xFF7F,0xFFC0,
   0xFE7F,0xFF80,
   0xFE7F,0xFF00,
   0xFE7F,0xFF80,
   0xFEFF,0xFFC0,
   0x7FFF,0xFFE0,
   0x3FFF,0xFBF0,
   0x07FC,0x7878
};
struct Image okImage = {
	(REQGW-OKGW)/2, 1,		/* LeftEdge, TopEdge */
	29, 11, 2,	/* Width, Height, Depth */
	&okData[0],	/* ImageData */
	0x03, 0x00,	/* PlanePick, PlaneOnOff */
	NULL		/* NextImage */
};
struct Gadget okGadg = {
	&cancelGadg,		/* NextGadget */
	REQGL, REQGB,		/* LeftEdge, TopEdge */
	REQGW, REQGH,		/* Width, Height */
	GADGIMAGE | GADGHBOX | GRELBOTTOM,	/* Flags */
	RELVERIFY | ENDGADGET,	/* Activation */
	BOOLGADGET | REQGADGET,	/* GadgetType */
	(APTR)&okImage,	/* GadgetRender */
	NULL,		/* SelectRender */
	NULL,		/* GadgetText */
	0L,		/* MutualExclude */
	NULL,		/* SpecialInfo */
	OKID,		/* GadgetID */
	NULL,		/* UserData */
};


/*      Layout dell'Help dei tasti

         Up & Down -> Smooth scroll
   SHIFT Up & Down -> Fast scroll
     ALT Up & Down -> Turbo scroll
      Left & Right -> Jump to Previous & Next Screen
SHIFT Left & Right -> Scroll to Previous & Next Screen
  ALT Left & Right -> Jump to Start & End of file
SPACE (SHIFT, ALT) -> AutoScroll (fast, turbo)
             F1-F3 -> Show File#1-3
             F4-F5 -> Jump to Mark
       SHIFT F4-F5 -> Set Mark
                F6 -> Set First line to print
                F7 -> Set Last line to print
                F8 -> Search Next
                F9 -> Load new file
               F10 -> Quit
              HELP -> This note

*/

struct	IntuiText	helptext16=
	{
	2, 0,
	JAM1,
	HELPL+0*8, FREEMT,
	&taitalic,
	"Free memory:          ",     /* testo */
	NULL
	};
struct	IntuiText	helptext15=
	{
	2, 0,
	JAM1,
	HELPL+14*8, HELPTT+HELPTD*15+HELPG*9,
	&tanormal,
	"HELP -> This note",     /* testo */
	&helptext16
	};
struct	IntuiText	helptext14=
	{
	2, 0,
	JAM1,
	HELPL+15*8, HELPTT+HELPTD*14+HELPG*8,
	&tanormal,
	"F10 -> Quit",     /* testo */
	&helptext15
	};
struct	IntuiText	helptext13=
	{
	2, 0,
	JAM1,
	HELPL+16*8, HELPTT+HELPTD*13+HELPG*7,
	&tanormal,
	"F9 -> Load new file",     /* testo */
	&helptext14
	};
struct	IntuiText	helptext12=
	{
	2, 0,
	JAM1,
	HELPL+16*8, HELPTT+HELPTD*12+HELPG*6,
	&tanormal,
	"F8 -> Search Next",     /* testo */
	&helptext13
	};
struct	IntuiText	helptext11=
	{
	2, 0,
	JAM1,
	HELPL+16*8, HELPTT+HELPTD*11+HELPG*5,
	&tanormal,
	"F7 -> Set Last line to print",     /* testo */
	&helptext12
	};
struct	IntuiText	helptext10=
	{
	2, 0,
	JAM1,
	HELPL+16*8, HELPTT+HELPTD*10+HELPG*5,
	&tanormal,
	"F6 -> Set First line to print",     /* testo */
	&helptext11
	};
struct	IntuiText	helptext9=
	{
	2, 0,
	JAM1,
	HELPL+7*8, HELPTT+HELPTD*9+HELPG*4,
	&tanormal,
	"SHIFT F4-F5 -> Set Mark",     /* testo */
	&helptext10
	};
struct	IntuiText	helptext8=
	{
	2, 0,
	JAM1,
	HELPL+13*8, HELPTT+HELPTD*8+HELPG*4,
	&tanormal,
	"F4-F5 -> Jump to Mark",     /* testo */
	&helptext9
	};
struct	IntuiText	helptext7=
	{
	2, 0,
	JAM1,
	HELPL+13*8, HELPTT+HELPTD*7+HELPG*3,
	&tanormal,
	"F1-F3 -> Show File#1-3",     /* testo */
	&helptext8
	};
struct	IntuiText	helptext6=
	{
	2, 0,
	JAM1,
	HELPL+0*8, HELPTT+HELPTD*6+HELPG*2,
	&tanormal,
	"SPACE (SHIFT, ALT) -> AutoScroll (fast, turbo)",     /* testo */
	&helptext7
	};
struct	IntuiText	helptext5=
	{
	2, 0,
	JAM1,
	HELPL+2*8, HELPTT+HELPTD*5+HELPG,
	&tanormal,
	"ALT Left & Right -> Jump to Start & End of file",     /* testo */
	&helptext6
	};
struct	IntuiText	helptext4=
	{
	2, 0,
	JAM1,
	HELPL+0*8, HELPTT+HELPTD*4+HELPG,
	&tanormal,
	"SHIFT Left & Right -> Scroll to Previous & Next Screen",     /* testo */
	&helptext5
	};
struct	IntuiText	helptext3=
	{
	2, 0,
	JAM1,
	HELPL+6*8, HELPTT+HELPTD*3+HELPG,
	&tanormal,
	"Left & Right -> Jump to Previous & Next Screen",     /* testo */
	&helptext4
	};
struct	IntuiText	helptext2=
	{
	2, 0,
	JAM1,
	HELPL+5*8, HELPTT+HELPTD*2,
	&tanormal,
	"ALT Up & Down -> Turbo scroll",     /* testo */
	&helptext3
	};
struct	IntuiText	helptext1=
	{
	2, 0,
	JAM1,
	HELPL+3*8, HELPTT+HELPTD,
	&tanormal,
	"SHIFT Up & Down -> Fast scroll",     /* testo */
	&helptext2
	};
struct	IntuiText	helptext0=
	{
	2, 0,
	JAM1,
	HELPL+9*8, HELPTT,
	&tanormal,
	"Up & Down -> Smooth scroll",     /* testo */
	&helptext1
	};
struct	IntuiText	helptext=
	{
	2, 0,
	JAM1,
	(HREQW-14*8)/2, 9,
	&tabold,
	"About The Keys",     /* testo */
	&helptext0
	};
SHORT	hreqborderdata[]=
	{
	4, 2,
	HREQW-1-4-1, 2,
	HREQW-1-4-1, HREQH-1-2,
	4, HREQH-1-2,
	4, 2
	};
struct	Border	hreqborder2=
	{
	1, 0,
	3, 0,
	JAM1,
	5,
	hreqborderdata,
	NULL		/*   next Border   */
	};
struct	Border	helpreqborder=
	{
	0, 0,
	3, 0,
	JAM1,
	5,
	hreqborderdata,
	&hreqborder2		/*   next Border   */
	};
struct Requester	helprequester=
	{
	NULL,
	(WINDOWW-HREQW)/2, ((256-11)-HREQH)/2,
	HREQW, HREQH,
	NULL, NULL,
	&cancelGadg,		/*   Gadget   */
	&helpreqborder,		/*   Border   */
	&helptext,		/*   Text   */
	NOISYREQ,
	1		/*   BackFill   */
	};


UBYTE	jumptobuff[ LINELEN ];
struct	StringInfo	jumptogstrinfo=
	{
	jumptobuff,
	NULL,
	0,
	LINELEN,
	0
	};
struct	IntuiText	jttext=
	{
	2, 0,
	JAM1,
	-(5*8), 0,
	&tanormal,
	"Line:",     /* testo */
	NULL
	};
struct	Gadget	jumptogadg=
	{
	&okGadg,		/*   Next   */
	(REQW-5*8-(LINELEN-1)*8)/2+5*8, 40,
	(LINELEN-1)*8, 8,
	GADGHCOMP,
	RELVERIFY | LONGINT | ENDGADGET,
	STRGADGET | REQGADGET,
	NULL,
	NULL,
	&jttext,		/*   Text   */
	NULL,
	(APTR)&jumptogstrinfo,
	JUMPTOID,		/*   ID   */
	NULL
	};

struct	IntuiText	jumptotext=
	{
	2, 0,
	JAM1,
	(REQW-21*8)/2, 15,
	&tabold,
	"Jump to a line number",     /* testo */
	NULL
	};


struct	IntuiText	waitprinttext=
	{
	2, 0,
	JAM1,
	(REQW-28*8)/2, 28,
	&tabold,
	"Wait please, I'm printing...",     /* testo */
	NULL
	};

UBYTE	sendtobuff[ SENDTOLEN ]="PRT:";
struct	StringInfo	sendtogstrinfo=
	{
	sendtobuff,
	NULL,
	4,
	SENDTOLEN,
	0
	};
struct	IntuiText	sendtogtext=
	{
	2, 0,
	JAM1,
	-(8*8), 0,
	&tanormal,
	"Send to:",     /* testo */
	NULL
	};
struct	Gadget	sendtogadg=
	{
	&okGadg,		/*   Next   */
	8*8+PRINTGL, 50,
	REQW-(PRINTGL*2+8*8)-8, 8,
	GADGHCOMP,
	RELVERIFY | ENDGADGET,
	STRGADGET | REQGADGET,
	NULL,
	NULL,
	&sendtogtext,		/*   Text   */
	NULL,
	(APTR)&sendtogstrinfo,
	PRINTID,		/*   ID   */
	NULL
	};

UBYTE	tobuff[ LINELEN ];
struct	StringInfo	togstrinfo=
	{
	tobuff,
	NULL,
	0,
	LINELEN,
	0
	};
struct	IntuiText	togtext=
	{
	2, 0,
	JAM1,
	-(3*8), 0,
	&tanormal,
	"To:",     /* testo */
	NULL
	};
struct	Gadget	togadg=
	{
	&sendtogadg,		/*   Next   */
	REQW-(PRINTGL+LINELEN*8), 30,
	(LINELEN-1)*8, 8,
	GADGHCOMP,
	RELVERIFY | LONGINT,
	STRGADGET | REQGADGET,
	NULL,
	NULL,
	&togtext,		/*   Text   */
	NULL,
	(APTR)&togstrinfo,
	TOID,		/*   ID   */
	NULL
	};

UBYTE	frombuff[ LINELEN ];
struct	StringInfo	fromgstrinfo=
	{
	frombuff,
	NULL,
	0,
	LINELEN,
	0
	};
struct	IntuiText	fromgtext=
	{
	2, 0,
	JAM1,
	-(5*8), 0,
	&tanormal,
	"From:",     /* testo */
	NULL
	};
struct	Gadget	fromgadg=
	{
	&togadg,		/*   Next   */
	5*8+PRINTGL, 30,
	(LINELEN-1)*8, 8,
	GADGHCOMP,
	RELVERIFY | LONGINT,
	STRGADGET | REQGADGET,
	NULL,
	NULL,
	&fromgtext,		/*   Text   */
	NULL,
	(APTR)&fromgstrinfo,
	FROMID,		/*   ID   */
	NULL
	};

struct	IntuiText	printtext=
	{
	2, 0,
	JAM1,
	(REQW-22*8)/2, 10,
	&tabold,
	"Print a range of lines",     /* testo */
	NULL
	};


UBYTE	searchbuff[ SEARCHLEN ];
struct	StringInfo	searchgstrinfo=
	{
	searchbuff,
	NULL,
	0,
	SEARCHLEN,
	0
	};
struct	Gadget	searchgadg=
	{
	&okGadg,		/*   Next   */
	(REQW-SEARCHLEN*8)/2, 40,
	SEARCHLEN*8, 8,
	GADGHCOMP,
	RELVERIFY | STRINGCENTER | ENDGADGET,
	STRGADGET | REQGADGET,
	NULL,
	NULL,
	NULL,		/*   Text   */
	NULL,
	(APTR)&searchgstrinfo,
	SEARCHID,		/*   ID   */
	NULL
	};

struct	IntuiText	searchtext=
	{
	2, 0,
	JAM1,
	(REQW-19*8)/2, 15,
	&tabold,
	"Search for a string",     /* testo */
	NULL
	};


SHORT	reqborderdata[]=
	{
	4, 2,
	REQW-1-4-1, 2,
	REQW-1-4-1, REQH-1-2,
	4, REQH-1-2,
	4, 2
	};
struct	Border	reqborder2=
	{
	1, 0,
	3, 0,
	JAM1,
	5,
	reqborderdata,
	NULL		/*   next Border   */
	};
struct	Border	reqborder=
	{
	0, 0,
	3, 0,
	JAM1,
	5,
	reqborderdata,
	&reqborder2		/*   next Border   */
	};
struct Requester	requester=
	{
	NULL,
	(WINDOWW-REQW)/2, ((256-11)-REQH)/2,
	REQW, REQH,
	NULL, NULL,
	NULL,		/*   Gadget   */
	&reqborder,		/*   Border   */
	NULL,		/*   Text   */
	NULL,		/*   Flags   */
	1		/*   BackFill   */
	};


struct	IntuiText	waittext=
	{
	1, 0,
	JAM1,
	(WINDOWW-(26*8))/2, 0,
	&taunderlined,
	" WAIT please, I'm loading ",
	NULL
	};

struct	IntuiText	formattext=
	{
	1, 0,
	JAM1,
	(WINDOWW-(30*8))/2, 0,
	&taunderlined,
	" WAIT please, I'm reformatting ",
	NULL
	};

struct	IntuiText	messtesto=     /* strutture usate da messaggio() */
	{
	2, 0,
	JAM1,
	0, 15,
	&tabold,
	NULL,     /* testo */
	NULL
	};
struct	IntuiText	messpositivo=
	{
	3, 0,
	JAM1,
	AUTOLEFTEDGE, AUTOTOPEDGE,
	NULL,
	NULL,     /* testo */
	NULL
	};
struct	IntuiText	messnegativo=
	{
	3, 0,
	JAM1,
	AUTOLEFTEDGE, AUTOTOPEDGE,
	NULL,
	NULL,     /* testo */
	NULL
	};


struct	IntuiText	itext21=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"8",
	NULL
	};
struct	MenuItem	item21=
	{
	NULL,
	ITEMB+ITEMB2+4*8+2-MENUL+(3*8+CHECKWIDTH+8)+(1*8+CHECKWIDTH+8)*3, SITEMT+SITEMD*5+ITEMGAP+ITEMGAP2,
	1*8+CHECKWIDTH, 10,
	CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x1E0000,
	(APTR)&itext21,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext20=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"4",
	NULL
	};
struct	MenuItem	item20=
	{
	&item21,
	ITEMB+ITEMB2+4*8+2-MENUL+(3*8+CHECKWIDTH+8)+(1*8+CHECKWIDTH+8)*2, SITEMT+SITEMD*5+ITEMGAP+ITEMGAP2,
	1*8+CHECKWIDTH, 10,
	CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x2E0000,
	(APTR)&itext20,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext19=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"2",
	NULL
	};
struct	MenuItem	item19=
	{
	&item20,
	ITEMB+ITEMB2+4*8+2-MENUL+(3*8+CHECKWIDTH+8)+(1*8+CHECKWIDTH+8), SITEMT+SITEMD*5+ITEMGAP+ITEMGAP2,
	1*8+CHECKWIDTH, 10,
	CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x360000,
	(APTR)&itext19,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext18=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"1",
	NULL
	};
struct	MenuItem	item18=
	{
	&item19,
	ITEMB+ITEMB2+4*8+2-MENUL+(3*8+CHECKWIDTH+8), SITEMT+SITEMD*5+ITEMGAP+ITEMGAP2,
	1*8+CHECKWIDTH, 10,
	CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x3A0000,
	(APTR)&itext18,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext17b=
	{
	3, 0,
	JAM1,
	-4*8-2, 1,
	NULL,
	"Tab:",
	NULL
	};
struct	IntuiText	itext17=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"OFF",
	&itext17b
	};
struct	MenuItem	item17=
	{
	&item18,
	ITEMB+ITEMB2+4*8+2-MENUL, SITEMT+SITEMD*5+ITEMGAP+ITEMGAP2,
	3*8+CHECKWIDTH, 10,
	CHECKED | CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x3C0000,
	(APTR)&itext17,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext16=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"ON",
	NULL
	};
struct	MenuItem	item16=
	{
	&item17,
	MENUW-ITEMB-SITEMW+ITEMB2-MENUL+7*8+2+(3*8+CHECKWIDTH+4), SITEMT+SITEMD*4+ITEMGAP,
	2*8+CHECKWIDTH, 10,
	CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x8000,
	(APTR)&itext16,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext15b=
	{
	3, 0,
	JAM1,
	-7*8-2, 1,
	NULL,
	"W-Wrap:",
	NULL
	};
struct	IntuiText	itext15=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"OFF",
	&itext15b
	};
struct	MenuItem	item15=
	{
	&item16,
	MENUW-ITEMB-SITEMW+ITEMB2-MENUL+7*8+2, SITEMT+SITEMD*4+ITEMGAP,
	3*8+CHECKWIDTH, 10,
	CHECKED | CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x10000,
	(APTR)&itext15,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext14=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"3",
	NULL
	};
struct	MenuItem	item14=
	{
	&item15,
	ITEMB+ITEMB2+6*8+2-MENUL+(1*8+CHECKWIDTH+4)*2, SITEMT+SITEMD*4+ITEMGAP,
	1*8+CHECKWIDTH, 10,
	CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x3000,
	(APTR)&itext14,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext13=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"2",
	NULL
	};
struct	MenuItem	item13=
	{
	&item14,
	ITEMB+ITEMB2+6*8+2-MENUL+(1*8+CHECKWIDTH+4), SITEMT+SITEMD*4+ITEMGAP,
	1*8+CHECKWIDTH, 10,
	CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x5000,
	(APTR)&itext13,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext12b=
	{
	3, 0,
	JAM1,
	-6*8-2, 1,
	NULL,
	"File#:",
	NULL
	};
struct	IntuiText	itext12=
	{
	1, 0,
	JAM1,
	CHECKWIDTH-2, 1,
	NULL,
	"1",
	&itext12b
	};
struct	MenuItem	item12=
	{
	&item13,
	ITEMB+ITEMB2+6*8+2-MENUL, SITEMT+SITEMD*4+ITEMGAP,
	1*8+CHECKWIDTH, 10,
	CHECKED | CHECKIT | ITEMTEXT | ITEMENABLED | HIGHCOMP,
	0x6000,		/*   ***   */
	(APTR)&itext12,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext11=
	{
	1, 0,
	JAM1,
	ITEMB2, 2,
	NULL,
	"About the keys",
	NULL
	};
struct	MenuItem	item11=
	{
	&item12,
	MENUW-ITEMB-SITEMW-MENUL, SITEMT+SITEMD*3,
	SITEMW, 12,
	ITEMTEXT | ITEMENABLED | HIGHCOMP,
	NULL,
	(APTR)&itext11,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext10=
	{
	1, 0,
	JAM1,
	ITEMB2, 2,
	NULL,
	"Use my colors",
	NULL
	};
struct	MenuItem	item10=
	{
	&item11,
	ITEMB-MENUL, SITEMT+SITEMD*3,
	SITEMW, 12,
	ITEMTEXT | ITEMENABLED | HIGHCOMP,
	NULL,
	(APTR)&itext10,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext9=
	{
	1, 0,
	JAM1,
	ITEMB2, 2,
	NULL,
	"Clear file",
	NULL
	};
struct	MenuItem	item9=
	{
	&item10,
	MENUW-ITEMB-SITEMW-MENUL, SITEMT+SITEMD*2,
	SITEMW, 12,
	ITEMTEXT | ITEMENABLED | HIGHCOMP | COMMSEQ,
	NULL,
	(APTR)&itext9,
	NULL,
	'C',
	NULL,
	NULL,
	};

struct	IntuiText	itext8=
	{
	1, 0,
	JAM1,
	ITEMB2, 2,
	NULL,
	"Jump to",
	NULL
	};
struct	MenuItem	item8=
	{
	&item9,
	ITEMB-MENUL, SITEMT+SITEMD*2,
	SITEMW, 12,
	ITEMTEXT | ITEMENABLED | HIGHCOMP | COMMSEQ,
	NULL,
	(APTR)&itext8,
	NULL,
	'J',
	NULL,
	NULL,
	};

struct	IntuiText	itext7=
	{
	1, 0,
	JAM1,
	ITEMB2, 2,
	NULL,
	"Print line",
	NULL
	};
struct	MenuItem	item7=
	{
	&item8,
	MENUW-ITEMB-SITEMW-MENUL, SITEMT+SITEMD,
	SITEMW, 12,
	ITEMTEXT | ITEMENABLED | HIGHCOMP | COMMSEQ,
	NULL,
	(APTR)&itext7,
	NULL,
	'L',
	NULL,
	NULL,
	};

struct	IntuiText	itext6=
	{
	1, 0,
	JAM1,
	ITEMB2, 2,
	NULL,
	"Print range",
	NULL
	};
struct	MenuItem	item6=
	{
	&item7,
	ITEMB-MENUL, SITEMT+SITEMD,
	SITEMW, 12,
	ITEMTEXT | ITEMENABLED | HIGHCOMP | COMMSEQ,
	NULL,
	(APTR)&itext6,
	NULL,
	'P',
	NULL,
	NULL,
	};

struct	IntuiText	itext5=
	{
	1, 0,
	JAM1,
	ITEMB2, 2,
	NULL,
	"Search next",
	NULL
	};
struct	MenuItem	item5=
	{
	&item6,
	MENUW-ITEMB-SITEMW-MENUL, SITEMT,
	SITEMW, 12,
	ITEMTEXT | ITEMENABLED | HIGHCOMP | COMMSEQ,
	NULL,
	(APTR)&itext5,
	NULL,
	'N',
	NULL,
	NULL,
	};

struct	IntuiText	itext4=
	{
	1, 0,
	JAM1,
	ITEMB2, 2,
	NULL,
    "Search",
	NULL
	};
struct	MenuItem	item4=
	{
	&item5,
	ITEMB-MENUL, SITEMT,
	SITEMW, 12,
	ITEMTEXT | ITEMENABLED | HIGHCOMP | COMMSEQ,
	NULL,
	(APTR)&itext4,
	NULL,
	'S',
	NULL,
	NULL,
	};

struct	IntuiText	itext3=
	{
	1, 0,
	JAM1,
	(125+8-4*8)/2, 4,
	NULL,
	"QUIT",
	NULL
	};
struct	MenuItem	item3=
	{
	&item4,
	MENUW-(125+8)-10-MENUL, 87,
	125+8, 15,
	ITEMTEXT | ITEMENABLED | HIGHBOX,
	NULL,
	(APTR)&itext3,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext2=
	{
	1, 0,
	JAM1,
	(125+8-9*8)/2, 4,
	NULL,
	"LOAD FILE",
	NULL
	};
struct	MenuItem	item2=
	{
	&item3,
	10-MENUL, 87,
	125+8, 15,
	ITEMTEXT | ITEMENABLED | HIGHBOX,
	NULL,
	(APTR)&itext2,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	MenuItem	item1=		/* Serve per dimensione ItemBox, e LOGO */
	{
	&item2,
	MENUW-MENUL, MENUH,
	0, 0,
	ITEMENABLED | HIGHCOMP,
	NULL,
	(APTR)&logoImage, /* 	(APTR)&itext1, */
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct	IntuiText	itext07=
	{
	3, 2,
	JAM1,
	0, 101,
	&tabold,
	"________________________________________",
	NULL
	};
struct	IntuiText	itext06=
	{
	3, 2,
	JAM1,
	0, INFOT+73,
	&tabold,
	"________________________________________",
	&itext07
	};
struct	IntuiText	itext05=
	{
	3, 2,
	JAM1,
	(MENUCAR-37)*8/2, INFOT+70,
	NULL,
	"Viale Francia 4, 90146 Palermo, Italy",
	&itext06
	};
struct	IntuiText	itext04b=
	{
	3, 2,
	JAM1,
	(MENUCAR-20)*8/2+3*8, INFOT+62,
	&taitalic,
	"Federico Giannici",
	&itext05
	};
struct	IntuiText	itext04=
	{
	3, 2,
	JAM1,
	(MENUCAR-20)*8/2, INFOT+62,
	NULL,
	"by",
	&itext04b
	};
struct	IntuiText	itext03=
	{
	3, 2,
	JAM1,
	(MENUCAR-36)*8/2, INFOT+54,
	NULL,
	"Concept, Code, Graphic & File-Finder",
	&itext04
	};
struct	IntuiText	itext02=
	{
	3, 2,
	JAM1,
	(MENUCAR-34)*8/2, INFOT+40,
	NULL,
	"It's PD, but don't modify or sell!",
	&itext03
	};
struct	MenuItem	item0=
	{
	&item1,
	0-MENUL, 0,
	0, 0,
	ITEMTEXT | ITEMENABLED | HIGHCOMP,
	NULL,
	(APTR)&itext02,
	NULL,
	NULL,
	NULL,
	NULL,
	};

struct  Menu    menu=
	{
	NULL,
	220, 0,
	200, 8,
	MENUENABLED,
	"   The MENU is here !",
	&item0
	};


struct	Image	propimm;

struct	PropInfo propinfo=
	{
	AUTOKNOB | FREEHORIZ,
	0x0, 0x0,
	0xFFFF, 0xFFFF
	};

struct	Gadget	propgadg=
	{
	NULL,
	36, -10,
	WINDOWW-36-36, 11,
	GADGHCOMP | GRELBOTTOM,
	GADGIMMEDIATE,
	PROPGADGET,
	(APTR)&propimm,
	NULL,
	NULL,
	NULL,
	(APTR)&propinfo,
	PROPID,
	NULL
	};


UWORD chip Immr2Data[66] = {
	/* BitPlane 0 */
   0x0000,0x0000,0x0000,
   0x7FFF,0xFFFF,0xE000,
   0x7E00,0xFFFF,0xE000,
   0x7F7F,0x01FF,0xE000,
   0x7F9F,0xFE03,0xE000,
   0x7FE7,0xFFFC,0x2000,
   0x7F9F,0xFE03,0xE000,
   0x7F7F,0x01FF,0xE000,
   0x7E00,0xFFFF,0xE000,
   0x7FFF,0xFFFF,0xE000,
   0x0000,0x0000,0x0000,
	/* BitPlane 1 */
   0xFFFF,0xFFFF,0xF000,
   0x8000,0x0000,0x1000,
   0x81FF,0x0000,0x1000,
   0x80FF,0xFE00,0x1000,
   0x807F,0xFFFC,0x1000,
   0x801F,0xFFFF,0xD000,
   0x807F,0xFFFC,0x1000,
   0x80FF,0xFE00,0x1000,
   0x81FF,0x0000,0x1000,
   0x8000,0x0000,0x1000,
   0xFFFF,0xFFFF,0xF000
};

struct Image Immr2Image = {
	0, 0,		/* LeftEdge, TopEdge */
	36, 11, 2,	/* Width, Height, Depth */
	&Immr2Data[0],	/* ImageData */
	0x03, 0x00,	/* PlanePick, PlaneOnOff */
	NULL		/* NextImage */
};

UWORD chip Immr1Data[66] = {
	/* BitPlane 0 */
   0x0000,0x0000,0x0000,
   0x7FFF,0xFFFF,0xE000,
   0x401F,0xFFFF,0xE000,
   0x6FE0,0x3FFF,0xE000,
   0x73FF,0xC07F,0xE000,
   0x7CFF,0xFF87,0xE000,
   0x73FF,0xC07F,0xE000,
   0x6FE0,0x3FFF,0xE000,
   0x401F,0xFFFF,0xE000,
   0x7FFF,0xFFFF,0xE000,
   0x0000,0x0000,0x0000,
	/* BitPlane 1 */
   0xFFFF,0xFFFF,0xF000,
   0x8000,0x0000,0x1000,
   0xBFE0,0x0000,0x1000,
   0x9FFF,0xC000,0x1000,
   0x8FFF,0xFF80,0x1000,
   0x83FF,0xFFF8,0x1000,
   0x8FFF,0xFF80,0x1000,
   0x9FFF,0xC000,0x1000,
   0xBFE0,0x0000,0x1000,
   0x8000,0x0000,0x1000,
   0xFFFF,0xFFFF,0xF000
};

struct Image Immr1Image = {
	0, 0,		/* LeftEdge, TopEdge */
	36, 11, 2,	/* Width, Height, Depth */
	&Immr1Data[0],	/* ImageData */
	0x03, 0x00,	/* PlanePick, PlaneOnOff */
	NULL		/* NextImage */
};

struct Gadget Immr1Gadg= {
	&propgadg,		/* NextGadget */
	WINDOWW-36, -10,		/* LeftEdge, TopEdge */
	36, 11,		/* Width, Height */
	GADGIMAGE | GADGHIMAGE | GRELBOTTOM,	/* Flags */
	GADGIMMEDIATE | RELVERIFY,	/* Activation */
	BOOLGADGET,	/* GadgetType */
	(APTR)&Immr1Image,	/* GadgetRender */
	(APTR)&Immr2Image,		/* SelectRender */
	NULL,		/* GadgetText */
	0L,		/* MutualExclude */
	NULL,		/* SpecialInfo */
	DOWNID,		/* GadgetID */
	NULL,		/* UserData */
};

UWORD chip Imml2Data[66] = {
	/* BitPlane 0 */
   0x0000,0x0000,0x0000,
   0x7FFF,0xFFFF,0xE000,
   0x7FFF,0xF007,0xE000,
   0x7FF8,0x0FEF,0xE000,
   0x7C07,0xFF9F,0xE000,
   0x43FF,0xFE7F,0xE000,
   0x7C07,0xFF9F,0xE000,
   0x7FF8,0x0FEF,0xE000,
   0x7FFF,0xF007,0xE000,
   0x7FFF,0xFFFF,0xE000,
   0x0000,0x0000,0x0000,
	/* BitPlane 1 */
   0xFFFF,0xFFFF,0xF000,
   0x8000,0x0000,0x1000,
   0x8000,0x0FF8,0x1000,
   0x8007,0xFFF0,0x1000,
   0x83FF,0xFFE0,0x1000,
   0xBFFF,0xFF80,0x1000,
   0x83FF,0xFFE0,0x1000,
   0x8007,0xFFF0,0x1000,
   0x8000,0x0FF8,0x1000,
   0x8000,0x0000,0x1000,
   0xFFFF,0xFFFF,0xF000
};

struct Image Imml2Image = {
	0, 0,		/* LeftEdge, TopEdge */
	36, 11, 2,	/* Width, Height, Depth */
	&Imml2Data[0],	/* ImageData */
	0x03, 0x00,	/* PlanePick, PlaneOnOff */
	NULL		/* NextImage */
};

UWORD chip Imml1Data[66] = {
	/* BitPlane 0 */
   0x0000,0x0000,0x0000,
   0x7FFF,0xFFFF,0xE000,
   0x7FFF,0xFF80,0x2000,
   0x7FFF,0xC07F,0x6000,
   0x7FE0,0x3FFC,0xE000,
   0x7E1F,0xFFF3,0xE000,
   0x7FE0,0x3FFC,0xE000,
   0x7FFF,0xC07F,0x6000,
   0x7FFF,0xFF80,0x2000,
   0x7FFF,0xFFFF,0xE000,
   0x0000,0x0000,0x0000,
	/* BitPlane 1 */
   0xFFFF,0xFFFF,0xF000,
   0x8000,0x0000,0x1000,
   0x8000,0x007F,0xD000,
   0x8000,0x3FFF,0x9000,
   0x801F,0xFFFF,0x1000,
   0x81FF,0xFFFC,0x1000,
   0x801F,0xFFFF,0x1000,
   0x8000,0x3FFF,0x9000,
   0x8000,0x007F,0xD000,
   0x8000,0x0000,0x1000,
   0xFFFF,0xFFFF,0xF000
};

struct Image Imml1Image = {
	0, 0,		/* LeftEdge, TopEdge */
	36, 11, 2,	/* Width, Height, Depth */
	&Imml1Data[0],	/* ImageData */
	0x03, 0x00,	/* PlanePick, PlaneOnOff */
	NULL		/* NextImage */
};

struct Gadget Imml1Gadg= {
	&Immr1Gadg,		/* NextGadget */
	0, -10,		/* LeftEdge, TopEdge */
	36, 11,		/* Width, Height */
	GADGIMAGE | GADGHIMAGE | GRELBOTTOM,	/* Flags */
	GADGIMMEDIATE | RELVERIFY,	/* Activation */
	BOOLGADGET,	/* GadgetType */
	(APTR)&Imml1Image,	/* GadgetRender */
	(APTR)&Imml2Image,		/* SelectRender */
	NULL,		/* GadgetText */
	0L,		/* MutualExclude */
	NULL,		/* SpecialInfo */
	UPID,		/* GadgetID */
	NULL,		/* UserData */
};


UWORD __chip checkData[16] = {
	/* BitPlane 0 */
   0x0033,
   0x0066,
   0x00CC,
   0x0198,
   0xCF30,
   0x6660,
   0x33C0,
   0x1980,
	/* BitPlane 1 */
   0xFFC3,
   0xFF87,
   0xFF0F,
   0xFE1F,
   0x0C3F,
   0x867F,
   0xC3FF,
   0xE1FF
};
struct Image checkImage = {
	0, 0,		/* LeftEdge, TopEdge */
	16, 8, 2,	/* Width, Height, Depth */
	&checkData[0],	/* ImageData */
	0x03, 0x00,	/* PlanePick, PlaneOnOff */
	NULL		/* NextImage */
};

UWORD	__chip	pointerdata[]=		/*   pointer trasparente   */
	{
	0, 0,
	0, 0,
	0, 0,
	};

struct  NewWindow windowdata=
	{
	0, 11, WINDOWW, 256-11,
	3, 2,
	IDCMPFLAGS,
	ACTIVATE | SMART_REFRESH | NOCAREREFRESH | BORDERLESS | BACKDROP | RMBTRAP,
	&Imml1Gadg,     /* Gadget */
	&checkImage,
	NULL,     /* Title */
	NULL,		/***** Puntatore allo screen, da mettere dopo *****/
	NULL,
	0, 0, 0, 0,
	CUSTOMSCREEN,
	};

UBYTE	defbartext[]="View80 v"VERSIONE"  File# :                Size:       Lines:      Line:      ";
UBYTE	bartext[ sizeof(defbartext) ]="This is View80 waiting for a file to show.";
#define	BTFN	19
#define	BTFILE	21
#define	BTFILELEN	15
#define	BTSIZE	42
#define	BTLINES 55
#define	BTLINE	66
#define	BTLINELEN	6

struct  NewScreen  screendata=
	{
	0, 0, 640, 256, 2,
	3, 2,
	HIRES,
	CUSTOMSCREEN,
	&tanormal,
	bartext,
	NULL,
	NULL
	};

struct	line
	{
	UBYTE	*add;
	UBYTE	len;
	};


/*****   Il mio set di caratteri   *****/
UWORD CharData[] = {
	0x7e00,0x7366,0x0cce,0xcef0,0x7e7e,0x3f7e,0xc37e,0xdbcc,
	0x0000,0x0000,0x0c00,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0018,0x6c6c,0x1800,0x3818,0x0c30,0x0000,0x0000,0x0003,
	0x3c18,0x3c3c,0x1c7e,0x1c7e,0x3c3c,0x0000,0x0c00,0x303c,
	0x7c18,0xfc3c,0xf8fe,0xfe3c,0x667e,0x0ee6,0xf082,0xc638,
	0xfc38,0xfc3c,0x7e66,0xc3c6,0xc3c3,0xfe3c,0xc03c,0x1000,
	0x1800,0xe000,0x0e00,0x1c00,0xe018,0x06e0,0x3800,0x0000,
	0x0000,0x0000,0x0800,0x0000,0x0000,0x000e,0x1870,0x72cc,
	0x7e00,0x7366,0x0cce,0xcef0,0x7e7e,0x3f7e,0xc37e,0xdbcc,
	0x7e00,0x7366,0x0cce,0xcef0,0x7e7e,0x3f7e,0xc37e,0xdbcc,
	0x180c,0x1c42,0xc318,0x3c66,0x7e30,0x003e,0x007e,0x7e3c,
	0x18f0,0xf018,0x007e,0x0000,0x3070,0x0020,0x20c0,0x1830,
	0x0c18,0x71c3,0x3c1f,0x3c60,0x1830,0x6630,0x0c18,0x66f8,
	0x7130,0x0c18,0x71c3,0x003d,0x300c,0x1866,0x06f0,0x7c30,
	0x0c18,0x7133,0x3c00,0x0030,0x0c18,0x6630,0x0c18,0x6660,
	0x7130,0x0c18,0x7166,0x0000,0x300c,0x1866,0x0cf0,0x667e,
	0xc3ff,0xdbdb,0xffdb,0xdbcf,0xdbdb,0xccdb,0xc3c3,0xdbcc,
	0x7eff,0x7366,0xffce,0xcef0,0x7e7e,0x3f7e,0xc37e,0xdbcc,
	0x003c,0x6c6c,0x3ec6,0x6c18,0x1818,0x6618,0x0000,0x0006,
	0x6638,0x6666,0x3c60,0x3066,0x6666,0x1818,0x1800,0x1866,
	0xc63c,0x6666,0x6c66,0x6666,0x6618,0x0666,0x60c6,0xe66c,
	0x666c,0x6666,0x5a66,0xc3c6,0x66c3,0xc630,0x600c,0x3800,
	0x1800,0x6000,0x0600,0x3600,0x6000,0x0060,0x1800,0x0000,
	0x0000,0x0000,0x1800,0x0000,0x0000,0x0018,0x1818,0x9c33,
	0xc3ff,0xdbdb,0xffdb,0xdbcf,0xdbdb,0xccdb,0xc3c3,0xdbcc,
	0xc3ff,0xdbdb,0xffdb,0xdbcf,0xdbdb,0xccdb,0xc3c3,0xdbcc,
	0x003e,0x363c,0x6618,0x4000,0x8148,0x3306,0x0081,0x0066,
	0x1818,0x1830,0x00f4,0x0000,0x7088,0xcc63,0x6323,0x0008,
	0x1024,0x8e18,0x663c,0x6610,0x2048,0x0008,0x1024,0x006c,
	0x8e08,0x1024,0x8e3c,0x6366,0x0810,0x2400,0x0860,0x6608,
	0x1024,0x8e00,0x6600,0x0008,0x1024,0x0008,0x1024,0x00fc,
	0x8e08,0x1024,0x8e00,0x1801,0x0810,0x2400,0x1060,0x0066,
	0x7e60,0x67db,0x6cf3,0x7ec0,0x7e73,0x3fff,0x3cff,0xffff,
	0xc360,0xdbdb,0x6cdb,0xdbcf,0xdbdb,0xccdb,0xc3c3,0xdbcc,
	0x003c,0x00fe,0x60cc,0x6830,0x300c,0x3c18,0x0000,0x000c,
	0x6e18,0x0606,0x6c7c,0x6006,0x6666,0x1818,0x307e,0x0c06,
	0xde3c,0x66c0,0x6660,0x60c0,0x6618,0x066c,0x60ee,0xf6c6,
	0x66c6,0x6670,0x1866,0x66c6,0x3c66,0x8c30,0x300c,0x6c00,
	0x0c3c,0x6c3c,0x363c,0x303b,0x6c38,0x0666,0x1866,0x7c3c,
	0xdc3d,0xec3e,0x3e66,0x6663,0x6366,0x7e18,0x1818,0x00cc,
	0x7e60,0x67db,0x6cf3,0x7ec0,0x7e73,0x3fff,0x3cff,0xffff,
	0x7e60,0x67db,0x6cf3,0x7ec0,0x7e73,0x3fff,0x3cff,0xffff,
	0x186c,0x3066,0x3c18,0x3c00,0x9d88,0x6600,0x7eb9,0x003c,
	0x7e30,0x3000,0xc6f4,0x1800,0x3088,0x6626,0x2666,0x183c,
	0x3c3c,0x3c3c,0x3c3c,0xc0fe,0xfefe,0xfe7e,0x7e7e,0x7e66,
	0xc63c,0x3c3c,0x3c66,0x36cf,0x6666,0x6666,0xc37e,0x663c,
	0x3c3c,0x3c3c,0x3c7e,0x3c3c,0x3c3c,0x3c38,0x3838,0x3818,
	0x7c3c,0x3c3c,0x3c3c,0x003e,0x6666,0x6666,0x667c,0x6666,
	0x0000,0x0000,0x1c00,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x7e00,0x67db,0x1cf3,0x7ec0,0x7e73,0x3fff,0x3cff,0xffff,
	0x0018,0x006c,0x3c18,0x7600,0x300c,0xff7e,0x007e,0x0018,
	0x7e18,0x1c1c,0xcc06,0x7c0c,0x3c3e,0x0000,0x6000,0x060c,
	0xde66,0x7cc0,0x6678,0x78ce,0x7e18,0x0678,0x60fe,0xdec6,
	0x7cc6,0x7c38,0x1866,0x66d6,0x183c,0x1830,0x180c,0xc600,
	0x0006,0x7666,0x6e66,0x7866,0x7618,0x066c,0x1877,0x6666,
	0x6666,0x7660,0x1866,0x666b,0x3666,0x4c70,0x180e,0x0033,
	0x0000,0x0000,0x1c00,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x1c00,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x186c,0x783c,0x1800,0x6600,0xb1f8,0xcc00,0x7eb9,0x0000,
	0x1860,0x1800,0xc674,0x1800,0x3070,0x332c,0x2c2c,0x3066,
	0x6666,0x6666,0x666f,0xc060,0x6060,0x6018,0x1818,0x18f6,
	0xe666,0x6666,0x66c3,0x1cdb,0x6666,0x6666,0x6663,0x6c06,
	0x0606,0x0606,0x061b,0x6666,0x6666,0x6618,0x1818,0x187c,
	0x6666,0x6666,0x6666,0x7e67,0x6666,0x6666,0x6666,0x6666,
	0x7e7e,0x7e7e,0x007e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0018,0x00fe,0x0630,0xdc00,0x300c,0x3c18,0x0000,0x0030,
	0x7618,0x3006,0xfe06,0x6618,0x6606,0x0000,0x3000,0x0c18,
	0xde7e,0x66c0,0x6660,0x60c6,0x6618,0x666c,0x62d6,0xcec6,
	0x60c6,0x6c0e,0x1866,0x3cfe,0x3c18,0x3230,0x0c0c,0x0000,
	0x001e,0x6660,0x667e,0x3066,0x6618,0x0678,0x186b,0x6666,
	0x6666,0x663c,0x1866,0x666b,0x1c66,0x1818,0x1818,0x00cc,
	0x7e7e,0x7e7e,0x007e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,
	0x7e7e,0x7e7e,0x007e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,
	0x3c3e,0x3042,0x3c18,0x3c00,0xb100,0x6600,0x00b1,0x0000,
	0x18f8,0xf000,0xc614,0x0000,0x3000,0x6619,0x1bd9,0x607e,
	0x7e7e,0x7e7e,0x7e7c,0x6678,0x7878,0x7818,0x1818,0x1866,
	0xd6c3,0xc3c3,0xc3c3,0x36f3,0x6666,0x6666,0x3c63,0x661e,
	0x1e1e,0x1e1e,0x1e7f,0x607e,0x7e7e,0x7e18,0x1818,0x18c6,
	0x6666,0x6666,0x6666,0x006b,0x6666,0x6666,0x6666,0x6666,
	0xc3c3,0xc3c3,0x7ec3,0xc3c3,0xc3c3,0xc3c3,0xc3c3,0xc3c3,
	0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,0xffff,
	0x0000,0x006c,0x7c66,0xcc00,0x1818,0x6618,0x1800,0x1860,
	0x6618,0x6666,0x0c66,0x6618,0x660c,0x1818,0x187e,0x1800,
	0xc0c3,0x6666,0x6c66,0x6066,0x6618,0x6666,0x66c6,0xc66c,
	0x606c,0x6666,0x1866,0x3cee,0x6618,0x6630,0x060c,0x0000,
	0x0066,0x6666,0x6660,0x303c,0x6618,0x066c,0x1863,0x6666,
	0x7c3e,0x6006,0x1a66,0x3c36,0x363c,0x3218,0x1818,0x0033,
	0xdbdb,0xdbdb,0x7edb,0xdbdb,0xdbdb,0xdbdb,0xdbdb,0xdbdb,
	0xdbdb,0xdbdb,0x7edb,0xdbdb,0xdbdb,0xdbdb,0xdbdb,0xdbdb,
	0x3c0c,0x3000,0x1818,0x0200,0x9dfc,0x3300,0x00a9,0x0000,
	0x0000,0x0000,0xee14,0x0000,0x00f8,0xcc33,0x3133,0x66c3,
	0xc3c3,0xc3c3,0xc3cc,0x3c60,0x6060,0x6018,0x1818,0x186c,
	0xce66,0x6666,0x6666,0x6366,0x6666,0x6666,0x187e,0x6666,
	0x6666,0x6666,0x66d8,0x6660,0x6060,0x6018,0x1818,0x18c6,
	0x6666,0x6666,0x6666,0x1873,0x6666,0x6666,0x3c7c,0x3c66,
	0x7e7e,0x7e7e,0xc37e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,
	0x6060,0x6060,0x6060,0x6060,0x6060,0x6060,0x6060,0x6060,
	0x0018,0x006c,0x18c6,0x7600,0x0c30,0x0000,0x1800,0x18c0,
	0x3c7e,0x7e3c,0x1e3c,0x3c18,0x3c38,0x1818,0x0c00,0x3018,
	0x78c3,0xfc3c,0xf8fe,0xf03e,0x667e,0x3ce6,0xfec6,0xc638,
	0xf03c,0xe33c,0x3c3e,0x18c6,0xc33c,0xfe3c,0x033c,0x0000,
	0x003b,0x3c3c,0x3b3c,0x78c6,0xe63c,0x66e6,0x3c63,0x663c,
	0x6006,0xf07c,0x0c3b,0x1836,0x6318,0x7e0e,0x1870,0x00cc,
	0x7e7e,0x7e7e,0xdb7e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,0x7e7e,
	0x7373,0x7373,0xdb73,0x7373,0x7373,0x7373,0x7373,0x7373,
	0x1800,0x7e00,0x3c18,0x3c00,0x8100,0x0000,0x0081,0x0000,
	0x7e00,0x0000,0xfa14,0x0018,0x0000,0x0067,0x6267,0x3cc3,
	0xc3c3,0xc3c3,0xc3cf,0x08fe,0xfefe,0xfe7e,0x7e7e,0x7ef8,
	0xc63c,0x3c3c,0x3c3c,0x00bc,0x3e3e,0x3e3e,0x3c60,0x6c3b,
	0x3b3b,0x3b3b,0x3b77,0x3c3c,0x3c3c,0x3c3c,0x3c3c,0x3c7c,
	0x663c,0x3c3c,0x3c3c,0x003e,0x3b3b,0x3b3b,0x1860,0x187e,
	0x0000,0x0000,0x7e00,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x3000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0030,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0006,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x00fe,
	0x0000,0x0000,0x0000,0x007c,0x0000,0x3c00,0x0000,0x0000,
	0xf007,0x0000,0x0000,0x0000,0x0070,0x0000,0x0000,0x0033,
	0x0000,0x0000,0x7e00,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x7300,0x0000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x7e00,0x0000,0x007e,0x0000,
	0x0000,0x0000,0xc000,0x0030,0x0000,0x0001,0x0701,0x0000,
	0x0000,0x0000,0x0000,0x3000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x00f0,0x6000,
	0x0000,0x0000,0x0000,0x1000,0x0000,0x0000,0x0000,0x0000,
	0x0000,0x0000,0x0000,0x0040,0x0000,0x0000,0x70f0,0x7000,
};

