/* musicserial.h */
/* for AlgoRhythms.c by Thomas E. Janzen */
#include	"devices/serial.h"
#include	"proto/exec.h"
#include	"exec/devices.h"

#define STARTFUNCT (0)
#define STOPFUNCT (1)
#define CLOCKFUNCT (2)
#include "AlgoRhythms.h"

void Open_MIDI_Port(void);
int WriteSer(struct IOExtSer *io,char *data,int length);
void PlayNoteOn(const struct NoteEvent *PlayEvent);
void PlayNoteOff(const struct NoteEvent *StopEvent);
void SendFunction(int Function);
void StopMIDI(void);
void StopAllNotes(const struct NoteEvent NotestoStop[]);

int SetParams(struct IOExtSer *io,unsigned long rbuf_len,
	unsigned char rlen,unsigned char wlen,unsigned long brk,
	unsigned long baud,unsigned char sf,
	unsigned long ta0,unsigned long ta1);
