
;   
;                                                                   
;                      DEMO III - XColor library                    
;                                                                   
;                                                                   
;                        by Roger Fischlin                          
;                           Steigerwaldweg 6                        
;                           6450 Hanau 7                            
;                           West Germany                            
;                                                                   
;   
;       To run this demo the xcolor library must be available !     
;   

;
; This small demo will turn the pointer colour into antique
; (Only on the aktive screen).
;



	incdir	"fh1:include/"			; path may be different
	include	"exec/exec_lib.i"
	include	"intuition/intuitionbase.i"
	include	"intuition/intuition.i"
	include	"intuition/intuition_lib.i"



	include	"fh1:Color/XColor.i"




	include	"misc/easystart.i"		; I love the Workbench !



	move.l	#XC_VERSION,d0		; open library
	lea.l	XColorName(pc),a1
	CALLEXEC	OpenLibrary
	tst.l	d0
	beq	NoLibrary
	move.l	d0,_XColorBase

	move.l	d0,a0		; XColor has already opened
	move.l	XCb_IntuitionBase(a0),a0	; the Intuition-Library - so why should I
	move.l	ib_ActiveScreen(a0),a0	; it a second time ????					

	lea.l	sc_ViewPort(a0),a0	; a0 ^ViewPort
	move.l	#17,d0		; pointer colours : 17,18,19
	moveq.l	#3,d1

	CALLXCOLOR	MakeAntique

	move.l	XCb_IntuitionBase(a6),a6	; remakeDisplay
	jsr	_LVORemakeDisplay(a6)

	move.l	_XColorBase,a1		; close library
	CALLEXEC	CloseLibrary
NoLibrary	moveq.l	#0,d0
	rts

XColorName	XCOLORNAME
_XColorBase	dc.l	0




