/*
   XCol-Definitions
   for XColor.library,  by Roger Fishlin
   created by lli, 24.1.90

*/

#ifndef LIBRARIES_XCOL_H
#include <libraries/xcolor.h>
#endif
struct XColorBase *XColorBase;
int CheckColor(struct ViewPort*,int);
int ReadRGB4(struct ViewPort*,int);
int WriteRGB4(struct ViewPort*,int,int);
struct ColorMap *ColorMapAdress(int,APTR);
int ExchangeColors(struct ViewPort*,int,int);
int CopyColors(struct ViewPort*,int,int);
int SpradColors(struct ViewPort*,int,int);
int ColorDepth(struct Screen*);
int ColorNumber(struct Screen*);
int MakeAntique(struct ViewPort*,int,int);
int MakeBW(struct ViewPort*,int,int);
int CopyToBuffer(struct ViewPort*,USHORT*,int,int);
int CopyToColorMap(struct ViewPort,int,int);
USHORT HSVtoRGB(long,long,long);
int RGBtoHSV(int,ULONG*);
int ColorRequester(struct ColorRequest*);

#ifndef  NO_PRAGMAS
#pragma libcall XColorBase CheckColor 1e 802
#pragma libcall XColorBase ReadRGB4 24 802
#pragma libcall XColorBase WriteRGB4 2a 10803
#pragma libcall XColorBase ColorMapAdress 30 8002
#pragma libcall XColorBase ExchangeColors 36 10803
#pragma libcall XColorBase CopyColors 3c 10803
#pragma libcall XColorBase SpreadColors 42 11803
#pragma libcall XColorBase ColorDepth 48 801
#pragma libcall XColorBase ColorNumber 4e 801
#pragma libcall XColorBase MakeAntique 54 10803
#pragma libcall XColorBase MakeBW 5a 10803
#pragma libcall XColorBase CopyToBuffer 60 109804
#pragma libcall XColorBase CopyToColorMap 66 10803
#pragma libcall XColorBase HSVtoRGB 6c 21003
#pragma libcall XColorBase RGBtoHSV 72 8002
#pragma libcall XColorBase ColorRequester 78 801
#endif

