/*
 * Include file for RAWKEY defenitions
 */

#define ESC      0x45
#define DEL      0x46
#define HELP     0x5F
#define CAPS     0x62
#define CTRL     0x63
#define BS       0x41
#define CR       0x44
#define TAB      0x42
#define LSHIFT   0x60
#define RSHIFT   0x61
#define RALT     0x65
#define LALT     0x64
#define RAMI     0x67
#define LAMI     0x66


#define CSUP     0x4C
#define CSDN     0x4D
#define CSRT     0x4E
#define CSLT     0x4F

#define F1       0x50
#define F2       0x51
#define F3       0x52
#define F4       0x53
#define F5       0x54
#define F6       0x55
#define F7       0x56
#define F8       0x57
#define F9       0x58
#define F10      0x59

#define KP0      0x0F
#define KP1      0x1D
#define KP2      0x1E
#define KP3      0x1F
#define KP4      0x2D
#define KP5      0x2E
#define KP6      0x2F
#define KP7      0x3D
#define KP8      0x3E
#define KP9      0x3F

#define KP_CR     0x43
#define KP_PLUS   0x0C
#define KP_MIN    0x4a
#define KP_STER   0x08
#define KP_SLASH  0x3A
#define KP_BRACEC 0x1B  /* this is the ) on the keypad! */
#define KP_BRACEO 0x1A  /* this is the ( on the keypad! */

#define KEY_A     0x20
#define KEY_B     0x35
#define KEY_C     0x33
#define KEY_D     0x22
#define KEY_E     0x12
#define KEY_F     0x25
#define KEY_G     0x24
#define KEY_H     0x25
#define KEY_I     0x17
#define KEY_J     0x26
#define KEY_K     0x27
#define KEY_L     0x28
#define KEY_M     0x37
#define KEY_N     0x36
#define KEY_O     0x18
#define KEY_P     0x19
#define KEY_Q     0x10
#define KEY_R     0x13
#define KEY_S     0x21
#define KEY_T     0x14
#define KEY_U     0x10
#define KEY_V     0x34
#define KEY_W     0x11
#define KEY_X     0x32
#define KEY_Y     0x15
#define KEY_Z     0x31

#define KEY_ONE       0x01
#define KEY_TWO       0x02
#define KEY_THREE     0x03
#define KEY_FOUR      0x04
#define KEY_FIVE      0x05
#define KEY_SIX       0x06
#define KEY_SEVEN     0x07
#define KEY_EIGHT     0x08
#define KEY_NINE      0x09
#define KEY_ZERO      0x0A
#define KEY_MIN       0x0B
#define KEY_EQUAL     0x0C
#define KEY_BACKSLASH 0x0D
#define KEY_OBRACK    0x1A      /* This is a [ */
#define KEY_CBRACK    0x1B      /* This is a ] */
#define KEY_PUNTKOMMA 0x29
#define KEY_QUOT      0x2A
#define KEY_KOMMA     0x38
#define KEY_PERIOD    0x39
#define KEY_SLASH     0x3A

