/****************************************************************************


							 File Header di SPY

							by Federico Giannici



-----------------------------------------------------------------------------
This source is provided for you to see the techniques I used to write SPY.
You can, obviously, use it to make your experiments and you can take some
routines to insert in your programs. But you CANNOT modify, recompile and
distribute the modified version to anyone without my permission.
Be a programmer not a copier.
-----------------------------------------------------------------------------

****************************************************************************/



/* #include	"exec/types.h" */
/* #include	"intuition/intuition.h" */
/* #include	"libraries/dos.h" */
/* #include	"string.h" */
/* #include	"clib/macros.h" */
/* #include	"proto/exec.h" */
/* #include	"proto/dos.h" */
/* #include	"proto/graphics.h" */
/* #include	"proto/intuition.h" */

#include	"General.h"		/*   Sostituisce i precedenti   */

#define	DOSVECTNUM	24		/*   Numero di nuovi vettori DOS   */
#define	EXECVECTNUM	15		/*   Numero di nuovi vettori EXEC   */
#define	VECTNUM		(DOSVECTNUM+EXECVECTNUM)		/*   Numero di nuovi vettori   */
#define	TUTTIV		(-1)		/*   Tutti i nuovi vettori   */

#define	OPENV		0		/*   Numeri dei nuovi vettori   */
#define	CLOSEV		1
#define	READV		2
#define	WRITEV		3
#define	INPUTV		4
#define	OUTPUTV		5

#define	LOCKV		6
#define	UNLOCKV		7
#define	DUPLOCKV	8
#define	EXAMINEV	9
#define	EXNEXTV		10
#define	INFOV		11

#define	DELETEFILEV	12
#define	RENAMEV		13
#define	CREATEDIRV	14
#define	CURRENTDIRV	15
#define	PARENTDIRV	16
#define	SEEKV		17

#define	EXECUTEV	18
#define	LOADSEGV	19
#define	UNLOADSEGV	20
#define	CREATEPROCV	21
#define	EXITV		22
#define	IOERRV		23

/*****   Inizio funzioni EXEC   *****/

#define	ALLOCMEMV		24
#define	OPENDEVICEV		25
#define	CLOSEDEVICEV	26
#define	ADDDEVICEV		27
#define	OPENLIBRARYV	28
#define	OLDOPENLIBRARYV	29
#define	CLOSELIBRARYV	30
#define	ADDLIBRARYV		31
#define	OPENRESOURCEV	32
#define	ADDRESOURCEV	33
#define	FINDPORTV		34
#define	ADDPORTV		35
#define	FINDSEMAPHOREV	36
#define	ADDSEMAPHOREV	37
#define	FINDNAMEV		38


#define	VERBOSE		(itemverbose.Flags & CHECKED)		/*   Utili negli if   */
#define	EVERYTIME	(itemeverytime.Flags & CHECKED)
#define	WAITGO		(itemwaitforgo.Flags & CHECKED)
#define	SCREENFLASH	(itemflashon.Flags & CHECKED)
#define	ACTIVATED	(itemactivated.Flags & CHECKED)
#define	PRINTER		(itemprinter.Flags & CHECKED)

#define	SPYPRIORITY	3			/*   Priorita` di SPY. Per un veloce refresh della finestra   */

